!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Module MoistBuoyancy
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: moistbuoyancy.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!

module MoistBuoyancy
  !
  !
  !

  !⥸塼ɤ߹ 
  use gridset, only:  SpcNum,            &! ؼο
    &                 DimXMin,           &! x β
    &                 DimXMax,           &! x ξ
    &                 DimZMin,           &! z β
    &                 DimZMax,           &! z ξ
    &                 DelX,              &! x γʻֳ
    &                 DelZ                ! z γʻֳ
  use basicset, only: CpDry,             &!ʬǮ
    &                 MolWtDry,          &!ʬʬ
    &                 Grav,              &!ϲ®
    &                 SpcWetID,          &!Žʬ ID
    &                 SpcWetSymbol,      &!Žʬ̾
    &                 MolWtWet,          &!Žʬʬ
    &                 xz_PotTempBasicZ,  &!ܾβ
    &                 xz_ExnerBasicZ,    &!ʡؿδܾ
    &                 xz_MixRtBasicZ      !ܾκ
  use ChemCalc, only: xz_LatentHeatPerMass       !Ǯ
  use ChemData, only: ChemData_OneSpcID
  use average,  only: xr_avr_xz, xz_avr_xr
  use differentiate_center4, only: xr_dz_xz

  !ۤηػ
  implicit none
  
  !°λ
  private
  
  !ؿ public 
  public MoistBuoy_Init
  public xz_MoistBuoyKm
  public xr_MoistBuoy

  !ѿ
  integer     :: LoopNum      = 0
  integer     :: GasNum(10)   = 0
  integer     :: CloudNum(10) = 0
  real(8)     :: Cm           = 2.0d-1
  real(8)     :: MixLen       = 0.0d0
  
  save GasNum, CloudNum, LoopNum
  save Cm, MixLen

contains

!!!------------------------------------------------------------------!!!
  subroutine MoistBuoy_Init( )

    !ۤηػ
    implicit none

    !ѿ
    integer                  :: s
    integer                  :: n1

    !-----------------------------------------------------------
    ! Υ
    !-----------------------------------------------------------
    MixLen = sqrt(DelX * DelZ) 
    
    !-----------------------------------------------------------
    ! γȵΤ ID Ȥ
    !-----------------------------------------------------------
    !ؼ椫γΤ, źʬ̤ݴ.
    LoopNum = 0
    SelectCloud: do s = 1, SpcNum
      
!      !'Cloud' Ȥʸ󤬴ޤޤΤθĿ
!      n1 = index(SpcWetSymbol(s), '-Cloud' )
!      if (n1 /= 0) then
!        LoopNum          = LoopNum + 1
!        CloudNum(LoopNum)= s
!        GasNum(LoopNum)  = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID(SpcWetSymbol(s)(1:n1-3) // '-g'))
!      end if

      !'-g' Ȥʸ󤬴ޤޤΤθĿ
      n1 = index(SpcWetSymbol(s), '-g' )
      if (n1 /= 0) then
        LoopNum          = LoopNum + 1
!        CloudNum(LoopNum)= s
        GasNum(LoopNum)  = s
      end if
    end do SelectCloud
    
    !-----------------------------------------------------------
    ! ǧ
    !-----------------------------------------------------------
    write(*,*) "MoistAdjust_Init, LoopNum:  ", LoopNum
!    write(*,*) "MoistAdjust_Init, CloudNum: ", CloudNum
    write(*,*) "MoistAdjust_Init, GasNum:   ", GasNum    

  end subroutine MoistBuoy_Init


!!!------------------------------------------------------------------!!!
  function xz_MoistBuoyKm(xz_Exner,  xz_PotTemp, xz_MixRt)
    !
    !ήͥ륮Ϲ׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ʡؿξ
    real(8), intent(in)  :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !̾
    real(8), intent(in)  :: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                               !Žʬκ
    real(8)              :: xz_MoistBuoyKm(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !Ϲ
    real(8)              :: xz_EquivPotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !
    real(8)              :: xz_Temp(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !
    real(8)              :: xz_LatentHeatPerMassAll(DimXMin:DimXMax, DimZMin:DimZMax, LoopNum)
                                               !Ǯ
    real(8)              :: xz_MixRtPerMolWt(DimXMin:DimXMax, DimZMin:DimZMax, LoopNum)
                                               ! / ʬ
    real(8)              :: xz_MixRtBasicZPerMolWt(DimXMin:DimXMax, DimZMin:DimZMax, LoopNum)
                                               !ܾκ / ʬ
    integer              :: s

    !
    xz_Temp                = 0.0d0
    xz_LatentHeatPerMassAll       = 0.0d0
    xz_MixRtPerMolWt       = 0.0d0
    xz_MixRtBasicZPerMolWt = 0.0d0

    !ν. ΤΤ
    xz_Temp = (xz_Exner + xz_ExnerBasicZ) * (xz_PotTemp + xz_PotTempBasicZ)
    do s = 1, LoopNum
      xz_MixRtPerMolWt(:,:,GasNum(s)) = xz_MixRt(:,:,GasNum(s)) / MolWtWet(GasNum(s))

      xz_MixRtBasicZPerMolWt(:,:,GasNum(s)) = &
        & xz_MixRtBasicZ(:,:,GasNum(s)) / MolWtWet(GasNum(s))

      xz_LatentHeatPerMassAll(:,:,GasNum(s)) = &
        &  (xz_MixRt(:,:,GasNum(s)) + xz_MixRtBasicZ(:,:,GasNum(s))) &
        &   * xz_LatentHeatPerMass(SpcWetID(CloudNum(s)), xz_Temp)
    end do
  
    !̤η׻
    xz_EquivPotTemp = 0.0d0 
    xz_EquivPotTemp =                                           & 
      &   sum(xz_LatentHeatPerMassAll, 3) / (CpDry * xz_ExnerBasicZ)   &
      & + xz_PotTempBasicZ                                      &
      &   * (                                                   &
      &       + sum(xz_MixRtPerMolWt, 3)                        &
      &           / ( +  1.0d0 / MolWtDry                       &
      &               + sum(xz_MixRtBasicZPerMolWt, 3) )        &
      &       - sum(xz_MixRt, 3)                                &
      &          / ( 1.0d0 + sum(xz_MixRtBasicZ, 3))            &
      &      )
    
    !Ϲη׻
    xz_MoistBuoyKm = 0.0d0
    xz_MoistBuoyKm = &
      &  - 3.0d0 * Grav * ( Cm ** 2.0d0 ) * ( MixLen ** 2.0d0 ) &
      &       * xz_avr_xr( xr_dz_xz( xz_EquivPotTemp ) ) &
      &       / ( 2.0d0 * xz_PotTempBasicZ )
    
  end function xz_MoistBuoyKm
  

!!!------------------------------------------------------------------------!!!
  function xr_MoistBuoy(xz_MixRt)
    !
    ! ľαư˸ϹΤ, 
    ! ʬ̤θ̤
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                               !Žʬκ
    real(8)              :: xr_MoistBuoy(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !Ϲ(ʬ̸)
    real(8)              :: xr_MoistBuoy2(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !Ϲ(ʬ̸)
    real(8)              :: xz_MixRtPerMolWt(DimXMin:DimXMax, DimZMin:DimZMax, LoopNum)
                                               ! / ʬ
    real(8)              :: xz_MixRtBasicZPerMolWt(DimXMin:DimXMax, DimZMin:DimZMax, LoopNum)
                                               !ܾκ / ʬ
    integer              :: s
    
    !
    xr_MoistBuoy           = 0.0d0
    xz_MixRtPerMolWt       = 0.0d0
    xz_MixRtBasicZPerMolWt = 0.0d0

    !ν. ΤΤ
    do s = 1, LoopNum
      xz_MixRtPerMolWt(:,:,GasNum(s)) = xz_MixRt(:,:,GasNum(s)) / MolWtWet(GasNum(s))

      xz_MixRtBasicZPerMolWt(:,:,GasNum(s)) = &
        & xz_MixRtBasicZ(:,:,GasNum(s)) / MolWtWet(GasNum(s))
    end do
    
    !Ϲη׻
    xr_MoistBuoy =                                           &
      & + Grav * xr_avr_xz( sum(xz_MixRtPerMolWt, 3) )        &
      &    / ( 1.0d0 / MolWtDry                               &
      &        + xr_avr_xz( sum(xz_MixRtBasicZPerMolWt, 3) )) &
      & - Grav * xr_avr_xz( sum(xz_MixRt, 3) )                &
      &    / ( 1.0d0 + xr_avr_xz( sum(xz_MixRtBasicZ, 3) ) )

  end function xr_MoistBuoy

  
end module MoistBuoyancy
