!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Module MoistFunc
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: moistfunc.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!ʷ׻ġ뷲
!   * 麮Ѵ
!   * 椫麮Ѵ
!   * 椫Ѵ
!   * 椫Ѵ
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

module MoistFunc
  !
  !ñ̤δԤΥѥå⥸塼
  !   * 麮Ѵ
  !   * 椫麮Ѵ
  !   * 椫Ѵ
  !   * 椫Ѵ
  ! 

  !⥸塼ɤ߹
  use gridset, only:  DimXMin,       & ! x β
    &                 DimXMax,       & ! x ξ
    &                 DimZMin,       & ! z β
    &                 DimZMax          ! z ξ
  use basicset, only: PressSfc,      & !ɸవ               [Pa]
    &                 CpDry,         & !ʬʿ갵Ǯ [J/K kg]
    &                 MolWtDry,      & !ʬʿʬ   [kg/mol]
    &                 GasRDry          !ʬε     [J/K mol]
  use ChemCalc, only: SvapPress,      &!˰¾
    &                 xz_SvapPress,   &!˰¾
    &                 DSvapPressDTemp,&!˰¾βʬ
    &                 xz_DSvapPressDTemp, &!˰¾βʬ
    &                 ReactHeatNH4SHPerMass

  !ۤηػ
  implicit none 
  
  !°λ
  private

  !ؿ public ˻
  public Vap2MixRt, xz_Vap2MixRt 
  public MixRt2Vap, xz_MixRt2Vap
  public MolFr2MixRt, xz_MolFr2MixRt
  public MixRt2MolFr
  public Exner2Press, xz_Exner2Press
  public DMixRtSatDPotTemp, xz_DMixRtSatDPotTemp
  public DelMixRtNH4SH, DelMolFrNH4SH
  public xz_DelMixRtNH4SH
contains

!!!
!!!ܴؿ
!!!

!!!-----------------------------------------------------------------------!!!
  function Vap2MixRt(MolWt, VapAll, ExnerAll)
    !
    !漾. 
    !ŽʬϾʤ, 漾ˤۤ
    !
    
    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: MolWt            !ؼʬ
    real(8), intent(in) :: VapAll           !( + ܾ)
    real(8), intent(in) :: ExnerAll         !ʡؿ( + ܾ)
    real(8)             :: Vap2MixRt        !漾ؤѴ
    
    Vap2MixRt = 0.0d0
    Vap2MixRt = VapAll * MolWt / (MolWtDry * Exner2Press(ExnerAll))
    
  end function Vap2MixRt

  
  function xz_Vap2MixRt(MolWt, xz_VapAll, xz_ExnerAll)
    !
    !漾. 
    !ŽʬϾʤ, 漾ˤۤ
    !
    
    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: MolWt   !ؼʬ
    real(8), intent(in) :: xz_VapAll(DimXMin:DimXMax, DimZMin:DimZMax) 
                                   !(ʬȴܾ)   [Pa]
    real(8), intent(in) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax) 
                                   !ʡؿ(ʬȴܾ)
    real(8)             :: xz_Vap2MixRt(DimXMin:DimXMax, DimZMin:DimZMax)
                                   !麮ؤѴ
    integer             :: i, k

    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax

        xz_Vap2MixRt(i,k) = Vap2MixRt(MolWt, xz_VapAll(i,k), xz_ExnerAll(i,k))
      end do
    end do

!    write(*,*) minval(xz_VapAll(95,:)), maxval(xz_VapAll(95,:))
!    write(*,*) minval(xz_Vap2MixRt(95,:)), maxval(xz_Vap2MixRt(95,:))

  end function xz_Vap2MixRt
  
  
!!!-----------------------------------------------------------------------!!!
  function MolFr2MixRt(MolWt, MolFr)
    !
    !椫漾. 
    !
    
    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: MolWt            !ʬ
    real(8), intent(in) :: MolFr            !( + ܾ)
    real(8)             :: MolFr2MixRt      !椫麮ؤѴ

    MolFr2MixRt = 0.0d0
    MolFr2MixRt = MolFr * MolWt / MolWtDry     

  end function MolFr2MixRt


  function xz_MolFr2MixRt(MolWt, xz_MolFr)
    !
    !椫漾. 
    !
    
    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: MolWt            !ʬ
    real(8), intent(in) :: xz_MolFr(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !( + ܾ)
    real(8)             :: xz_MolFr2MixRt(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !椫麮ؤѴ
    integer             :: i, k

    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        xz_MolFr2MixRt(i,k) = MolFr2MixRt(MolWt, xz_MolFr(i,k)) 
      end do
    end do
    
  end function xz_MolFr2MixRt


!!!-----------------------------------------------------------------------!!!
  function MixRt2Vap(MolWt, MixRtV, ExnerAll)
    !
    !漾. 
    !
    
    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: MolWt            !ʬ
    real(8), intent(in) :: MixRtV           !( + ܾ)
    real(8), intent(in) :: ExnerAll         !ʡؿ( + ܾ)
    real(8)             :: MixRt2Vap        !椫ؤѴ
    
    MixRt2Vap = 0.0d0
    MixRt2Vap = MixRtV * Exner2Press(ExnerAll) * MolWtDry / MolWt 
    
  end function MixRt2Vap
  

  function xz_MixRt2Vap(MolWt, xz_MixRtV, xz_ExnerAll)
    !
    !漾. 
    !
    
    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: MolWt            !ʬ
    real(8), intent(in) :: xz_MixRtV(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !( + ܾ)
    real(8), intent(in) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !ʡؿ( + ܾ)
    real(8)             :: xz_MixRt2Vap(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !椫ؤѴ
    integer             :: i, k

    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax

        xz_MixRt2Vap(i,k) = MixRt2Vap(MolWt, xz_MixRtV(i,k), xz_ExnerAll(i,k))
      end do
    end do
        
  end function xz_MixRt2Vap
  

!!!-----------------------------------------------------------------------!!!
  function MixRt2MolFr(MolWt, MixRtV)
    !
    !漾. 
    !
    
    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: MolWt            !ʬ
    real(8), intent(in) :: MixRtV           !( + ܾ)
    real(8)             :: MixRt2MolFr      !椫ؤѴ

    MixRt2MolFr = 0.0d0
    MixRt2MolFr = MixRtV * MolWtDry / MolWt
    
  end function MixRt2MolFr


!!!-----------------------------------------------------------------------!!!
  function DMixRtSatDPotTemp(SpcID, MolWt, TempAll, ExnerAll)
    !
    !˰¾  ʬԤ
    !ºݤˤ, dq/dp * dp/dT * dT/d ¹. (â p ˰¾)
    !

    !ۤηػ
    implicit none 
    
    !ѿ
    integer, intent(in) :: SpcID
    real(8), intent(in) :: MolWt
    real(8), intent(in) :: TempAll          !( + ܾ)
    real(8), intent(in) :: ExnerAll         !ʡؿ( + ܾ)
    real(8)             :: DMixRtSatDSvapPress 
    real(8)             :: DMixRtSatDPotTemp   
                           
    DMixRtSatDSvapPress = 0.0d0
    DMixRtSatDPotTemp   = 0.0d0
    
    DMixRtSatDSvapPress =                                   &
      & Exner2Press(ExnerAll) * (MolWt / MolWtDry)          & 
      & / ((Exner2Press(ExnerAll)                           &
      &       - SvapPress(SpcID, TempAll)) ** 2.0d0)
    
    DMixRtSatDPotTemp =                         &
      &   DMixRtSatDSvapPress                   &
      & * DSvapPressDTemp(SpcID, TempAll)       &
      & * ExnerAll
    
  end function DMixRtSatDPotTemp


  function xz_DMixRtSatDPotTemp(SpcID, MolWt, xz_TempAll, xz_ExnerAll)
    !
    !˰¾  ʬԤ
    !ºݤˤ, dq/dp * dp/dT * dT/d ¹. (â p ˰¾)
    !

    !ۤηػ
    implicit none 
    
    !ѿ
    integer, intent(in) :: SpcID
    real(8), intent(in) :: MolWt
    real(8), intent(in) :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !( + ܾ)
    real(8), intent(in) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !ʡؿ( + ܾ)
    real(8)             :: xz_DMixRtSatDPotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
                           
    integer             :: i, k

    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        xz_DMixRtSatDPotTemp(i,k) = &
          & DMixRtSatDPotTemp(SpcID, MolWt, xz_TempAll(i,k), xz_ExnerAll(i,k))
      end do
    end do
    
  end function xz_DMixRtSatDPotTemp


!!!-----------------------------------------------------------------------!!!
  function Exner2Press(ExnerAll)
    !
    ! ʡؿϤ˴
    !

    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: ExnerAll         !ʡؿ( + ܾ)
    real(8)             :: Exner2Press
    
    Exner2Press = 0.0d0
    Exner2Press = PressSfc * (ExnerAll ** (CpDry / GasRDry))
    
  end function Exner2Press
  

  function xz_Exner2Press(xz_ExnerAll)
    !
    ! ʡؿϤ˴
    !

    !ۤηػ
    implicit none 
    
    !ѿ
    real(8), intent(in) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                            !ʡؿ( + ܾ)
    real(8)             :: xz_Exner2Press(DimXMin:DimXMax, DimZMin:DimZMax)
    integer             :: i, k

    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        xz_Exner2Press(i,k) = PressSfc * (xz_ExnerAll(i,k) ** (CpDry / GasRDry))
      end do
    end do
  end function xz_Exner2Press
  

!!!-----------------------------------------------------------------------!!!
  function DelMixRtNH4SH(TempAll, PressAll, MixRtNH3, MixRtH2S, MixRtNH4SH, &
    &                    MolWtNH3, MolWtH2S, MolWtNH4SH)
    !
    ! NH4SH ȿȼ, NH4SH ()
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: TempAll       !
    real(8), intent(in) :: PressAll      !
    real(8), intent(in) :: MixRtNH3      !NH3 κ
    real(8), intent(in) :: MixRtH2S      !H2S κ
    real(8), intent(in) :: MixRtNH4SH    !NH4SH κ
    real(8), intent(in) :: MolWtNH3      !NH3 ʬ
    real(8), intent(in) :: MolWtH2S      !H2S ʬ
    real(8), intent(in) :: MolWtNH4SH    !NH4SH ʬ
    real(8)             :: DelMixRtNH4SH !NH4SH κ
    real(8)             :: EquivConst    !ʿ
    real(8)             :: DelPressNH4SH !NH4SH ȯΰѲ
    real(8)             :: PPress(2)     !(ʬ)
    real(8)             :: Solution(2)   !(β)
    
    !˥βǤʬ
    PPress(1) = MixRt2MolFr( MolWtNH3, MixRtNH3 ) * PressAll
    PPress(2) = MixRt2MolFr( MolWtH2S, MixRtH2S ) * PressAll

    !NH4SH ƾȯ밵Ѳ
    DelPressNH4SH = MixRt2MolFr( MolWtNH4SH, MixRtNH4SH ) * PressAll

    !ʿ
    EquivConst = 61.781d0 - 10834.0d0 / TempAll - dlog(1.0d2)
    
    !ѲβȤƵ. 
    Solution(1) = 5.0d-1 * (sum(PPress) &
      &         + dsqrt( (PPress(1) - PPress(2))**2.0d0 &
      &                    + 4.0d0 * dexp(EquivConst)) )
    Solution(2) = 5.0d-1 * (sum(PPress) &
      &         - dsqrt( (PPress(1) - PPress(2))**2.0d0 &
      &                    + 4.0d0 * dexp(EquivConst)) )

    !ΩΥå
    !  ʿդξ, Ѳϰʲξ­ɬפ
    !    * NH4SH ƾȯ밵Ѳ礭
    !    * H2S  NH3 ʬ⾮
    !  ­ʤˤ, ѲϥȤʤ. 
    if ( minval(Solution, 1, Solution > - DelPressNH4SH) > minval(PPress, 1) ) then 
      DelMixRtNH4SH = 0.0d0
    else      
      DelMixRtNH4SH = MolFr2MixRt( MolWtNH4SH, minval(Solution, 1, Solution > - DelPressNH4SH) / PressAll )
    end if
   
!    write(*,*) 'DelMixRtNH4SH',  EquivConst
!    write(*,*) 'DelMixRtNH4SH',  DelPressNH4SH
!    write(*,*) 'DelMixRtNH4SH',  PPress
!    write(*,*) 'DelMixRtNH4SH',  Solution
!    write(*,*) 'DelMixRtNH4SH',  DelMixRtNH4SH

  end function DelMixRtNH4SH


!!!-----------------------------------------------------------------------!!!
  function xz_DelMixRtNH4SH(xz_TempAll, xz_PressAll, xz_MixRtNH3, xz_MixRtH2S, xz_MixRtNH4SH, &
    &                    MolWtNH3, MolWtH2S, MolWtNH4SH)
    !
    ! NH4SH ȿȼ, NH4SH ()
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                         !
    real(8), intent(in) :: xz_PressAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                         !
    real(8), intent(in) :: xz_MixRtNH3(DimXMin:DimXMax, DimZMin:DimZMax)
                                         !NH3 κ
    real(8), intent(in) :: xz_MixRtH2S(DimXMin:DimXMax, DimZMin:DimZMax)
                                         !H2S κ
    real(8), intent(in) :: xz_MixRtNH4SH(DimXMin:DimXMax, DimZMin:DimZMax)
                                         !NH4SH κ
    real(8), intent(in) :: MolWtNH3      !NH3 ʬ
    real(8), intent(in) :: MolWtH2S      !H2S ʬ
    real(8), intent(in) :: MolWtNH4SH    !NH4SH ʬ
    real(8)             :: xz_DelMixRtNH4SH(DimXMin:DimXMax, DimZMin:DimZMax)
                                         !NH4SH κ
    real(8)             :: EquivConst    !ʿ
    real(8)             :: DelPressNH4SH !NH4SH ȯΰѲ
    real(8)             :: PPress(2)     !(ʬ)
    real(8)             :: Solution(2)   !(β)
    integer             :: i, k

    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax

        !˥βǤʬ
        PPress(1) = MixRt2MolFr( MolWtNH3, xz_MixRtNH3(i,k) ) * xz_PressAll(i,k)
        PPress(2) = MixRt2MolFr( MolWtH2S, xz_MixRtH2S(i,k) ) * xz_PressAll(i,k)

        !NH4SH ƾȯ밵Ѳ
        DelPressNH4SH = MixRt2MolFr( MolWtNH4SH, xz_MixRtNH4SH(i,k) ) * xz_PressAll(i,k)
        
        !ʿ
        EquivConst = 61.781d0 - 10834.0d0 / xz_TempAll(i,k) - dlog(1.0d2)
        
        !ѲβȤƵ. 
        Solution(1) = 5.0d-1 * (sum(PPress) &
          &         + dsqrt( (PPress(1) - PPress(2))**2.0d0 &
          &                    + 4.0d0 * dexp(EquivConst)) )
        Solution(2) = 5.0d-1 * (sum(PPress) &
          &         - dsqrt( (PPress(1) - PPress(2))**2.0d0 &
          &                    + 4.0d0 * dexp(EquivConst)) )
        
        !ΩΥå
        !  ʿդξ, Ѳϰʲξ­ɬפ
        !    * NH4SH ƾȯ밵Ѳ礭
        !    * H2S  NH3 ʬ⾮
        !  ­ʤˤ, ѲϥȤʤ.
        if ( minval(Solution, 1, Solution > - DelPressNH4SH) > minval(PPress, 1) ) then 
          xz_DelMixRtNH4SH(i,k) = 0.0d0
        else      
          xz_DelMixRtNH4SH(i,k) = MolFr2MixRt( MolWtNH4SH, minval(Solution, 1, Solution > - DelPressNH4SH) / xz_PressAll(i,k) )
        end if
        
      end do
    end do
  end function xz_DelMixRtNH4SH


!!!-----------------------------------------------------------------------!!!
  function DelMolFrNH4SH(TempAll, PressAll, MolFrNH3, MolFrH2S)
    !
    ! NH4SH ȿȼ H2S  NH3 Υθʬ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: TempAll       !
    real(8), intent(in) :: PressAll      !
    real(8), intent(in) :: MolFrNH3      !NH3 Υ
    real(8), intent(in) :: MolFrH2S      !H2S Υ
    real(8)             :: DelMolFrNH4SH !NH4SH ȼѲ
    real(8)             :: EquivConst    !ʿ
    real(8)             :: PPress(2)     !(ʬ)
    real(8)             :: Solution(2)   !(β)

    !------------------------------------------------------------
    !NH4SH ʿվ
    !------------------------------------------------------------
    !˥βǤʬ
    PPress(1) = MolFrNH3 * PressAll
    PPress(2) = MolFrH2S * PressAll

    !ʿ
    EquivConst = 61.781d0 - 10834.0d0 / TempAll - dlog(1.0d2)
    
    !ѲβȤƵ. 
    Solution(1) = 5.0d-1 * (sum(PPress) &
      &         + dsqrt( (PPress(1) - PPress(2))**2.0d0 &
      &                    + 4.0d0 * dexp(EquivConst)) )
    Solution(2) = 5.0d-1 * (sum(PPress) &
      &         - dsqrt( (PPress(1) - PPress(2))**2.0d0 &
      &                    + 4.0d0 * dexp(EquivConst)) )
    
    !ΩΥå
    if ( minval(Solution, 1, Solution > 0.0d0) > minval(PPress, 1) ) then 
      DelMolFrNH4SH = 0.0d0
    else      
      DelMolFrNH4SH = minval(Solution, 1, Solution > 0.0d0) / PressAll
    end if

  end function DelMolFrNH4SH

end module MoistFunc
